import java.util.LinkedList;
/**
 * Denne klassen er laget for  gjre det enklere
 *  lese inn og hente ut data fra en likhetsmatrise.
 * Selve klassen representerer en likhetsmatrise.
 * Matrisen er bygd opp av en lenketliste som peker til
 * tabeller over flyttall.
 *
 * @author Ole Kristian Hvaale, 1. Februar 2006 
 * -----------------------------------------------------
 * Sist oppdatert: 2006/5/11
 * av: Ole Kristian Hvaale
 * Ryddet i kode.
 * 
 */

public class EqualityMatrix
{
	LinkedList listofarrays = new LinkedList();
	
	/**
	 * Legger til en tabell over flyttall til listen
	 * 
	 * @param array Tabell over flyttall
	 */
	public void addArray(float[] array)
	{
		listofarrays.add(array);
	}
	/**
	 * Henter ut listen over tabeller
	 * 
	 * @return Returnerer listen som inneholder pekere til tabellene over flyttall.
	 */
	public LinkedList getList()
	{
		return listofarrays;
	}
	/**
	 * Henter ut likheten mellom to noder
	 * 
	 * @param index1 Node man behandler
	 * @param index2 Node man vil sjekke likheten til node spesifisert i index1
	 * @return Returnerer Likheten mellom de spesifiserte nodene
	 */
	public float getEquality(int index1, int index2)
	{
		if(index1<index2)
		{
			float[] tmparray;
			tmparray = (float[])listofarrays.get(index2);

			return tmparray[index1];			
		}
		else	
		{
			float[] tmparray;
			tmparray = (float[])listofarrays.get(index1);
			
			return tmparray[index2];
		}
		
	}

}
