import java.awt.Font;
import java.awt.GraphicsConfiguration;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Enumeration;
import java.util.LinkedList;
import javax.media.j3d.Appearance;
import javax.media.j3d.Background;
import javax.media.j3d.Billboard;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.Group;
import javax.media.j3d.Material;
import javax.media.j3d.Node;
import javax.media.j3d.Shape3D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.TransparencyAttributes;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;
import com.sun.j3d.utils.picking.PickTool;

import com.sun.j3d.utils.picking.PickCanvas;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import com.sun.j3d.utils.behaviors.mouse.MouseTranslate;
import com.sun.j3d.utils.behaviors.mouse.MouseZoom;


import com.sun.j3d.utils.geometry.Primitive;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.geometry.Text2D;
import com.sun.j3d.utils.image.TextureLoader;

/**
 * Klassen inneholder logikk for opptegning av Java3d i forhold til
 * innlest data.
 * 
 * @author Ole Kristian Hvaale, 1. Februar 2006 
 * -----------------------------------------------------
 * Sist oppdatert: 2006/5/11
 * av: Ole Kristian Hvaale
 * Endringer: lagt til kode for  vise frekvensbilde og
 * lagt til mulighet til  g tilbake og fram til tidliger beskte
 * noder
 * ----------------------------------------------------- 
 *
 */
public class Gui extends Canvas3D implements MouseListener
{
	private BranchGroup objroot;
	private PickCanvas pickCanvas;
	private Primitive tmpobjekt = null;
	private Appearance defaultapp;
	private Appearance alternativeapp;

	private boolean showsylinderspicked;
	private boolean objektpicked = false;
	private boolean multidocuments = true;
	private boolean showcylinders = false;
	private final boolean CLUSTER = false;	
	private boolean frekvensbilde = false;
		
	private PopupMenu nodemeny = null;
	private MenuItem tmpmenuitem;
	
	private EqualityMatrix equalitymatrix;
	private LinkedList documentitemlist = new LinkedList();
	private String[] urlarray;
	private LinkedList stack1 = new LinkedList();
	private LinkedList stack2 = new LinkedList();
	private LinkedList totalhistory = new LinkedList();
	private Filereader filereader = new Filereader();

	private int[] frekvensarray;
	private int  nodenr = 0;
	private int count = 0;
	private DocumentItem tmpdocumentitem;
			
	private final float TRANS = 0.5f;//spesifiserer hvor transpareng sylindrene skal vre
	private float thresholdvalue = 0.40f;//hvor stor likhet som trengs for  tegne opp kant
	//private Color3f defaultcolor = new Color3f(0.6f, 0.8f, 1.0f);
	private Color3f defaultcolor = new Color3f(0.3f, 0.9f, 0.9f);
	
	private float sizeofspheres = 0.15f;
	private float sizeofcylinders = sizeofspheres/9;
	boolean showsky = false;
	private String nameoftestmap;
	private String url ="url.dat";
	private String sim ="Likhet.dat";
	private int frekvenslimit=1;
	
	
	/**
	 * Leser inn data som skal visualiseres
	 * oppretter scenen
	 * legger til en muslytter og en pickcanvas
	 * 
	 * 
	 * @param config
	 */
	public Gui(GraphicsConfiguration config, String testdata, float threshold, boolean sky)
	{	
		super( config );
		thresholdvalue=threshold;
		nameoftestmap=testdata;
		showsky = sky;
		SimpleUniverse simpleU = new SimpleUniverse(this);
		Transform3D t3d = new Transform3D();
	    t3d.set(new Vector3d(0,0, 25));
		simpleU.getViewingPlatform().getViewPlatformTransform().setTransform(t3d);
		
		readInDataForGraph();
	
		BranchGroup scene = createSceneGraph();
	    simpleU.addBranchGraph(scene);
	    pickCanvas = new PickCanvas(this, objroot); 
	    pickCanvas.setMode(PickCanvas.GEOMETRY);
	    nodemeny = new PopupMenu("Node");
	    simpleU.getCanvas().add(nodemeny);

	    this.addMouseListener(this);
	    
	}
		
	/**
	 *	Metoden leser inn og oppretter de dataene som trengs for  visualisere grafen.
	 *
	 */
	public void readInDataForGraph()
	{

		LinkedList matrixlist;
		float[] floatarray;
		
		filereader.readURLFile(nameoftestmap+"/"+url);
		filereader.readEqualityFile(nameoftestmap+"/"+sim);

		documentitemlist = filereader.getDocumentItemList();
		equalitymatrix = filereader.getEqualityMatrix();
		matrixlist = equalitymatrix.getList();

		for(int index = 0; index<documentitemlist.size(); index++)
		{
			for(int i =0; i<documentitemlist.size(); i++)
			{
				
				if(equalitymatrix.getEquality(index,i) >=thresholdvalue)
				{

					if(index==i)
					{
			//			System.out.println("i = index "+ "i" +i +" index " + index);
					}
					else if(index>i)
					{
					//	System.out.println("index "+index+" i "+ i);
						DocumentItem docitem = (DocumentItem)documentitemlist.get(index);
						DocumentItem docitemconnction = (DocumentItem)documentitemlist.get(i);
						docitem.addConnection(docitemconnction);
					}
					else
					{
				//		System.out.println("index "+index+" i "+ i);						
						DocumentItem docitem = (DocumentItem)documentitemlist.get(index);
						DocumentItem docitemconnction = (DocumentItem)documentitemlist.get(i);
						docitem.addConnection(docitemconnction);				
						
					}
						
				}
								
			}
						
		}
		
		// hvis data finnes. pne fil og les in verdier.
		boolean dataisonfile;
		dataisonfile = filereader.readGraphData(documentitemlist, nameoftestmap);
		
		if(!dataisonfile)
		{
			preformSpringEmbedder(equalitymatrix, documentitemlist);
			filereader.writeGraphData(documentitemlist, nameoftestmap);
		}
		if(filereader.readFrekvensFile(nameoftestmap))
		{
			frekvensarray = filereader.getFrekArray();
		}
		else
		{
			frekvensarray = new int[documentitemlist.size()];
			for(int i =0; i<frekvensarray.length; i++)
			{
				frekvensarray[i]=0;
			}
			//m opprette tomt array her hvis den ikke ekisterer
		}
				
	}
	/**
	 *  Utfrer springembedder p listen over noder, p bakgrunn av likhetsmatrisen
	 *  
	 * @param em Likhetsmatrisen til nodene
	 * @param list listen over nodene
	 */
	public void preformSpringEmbedder(EqualityMatrix em, LinkedList list)
	{
		SpringEmbedder springembedder = new SpringEmbedder(em, list );
		springembedder.preformSpringEmbedder();
	}
	/**
	 * Oppretter Rotate/translate og mouse zoom til grafen
	 * legger til graf objektene, lys og bakgrunn
	 * 
	 * @return Returnerer BranchGroup som legges til scenen
	 */
	public BranchGroup createSceneGraph()
	{
		objroot = new BranchGroup();
	
		TransformGroup objTransform = new TransformGroup();
        objTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        objTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        objroot.addChild(objTransform);
        
		MouseRotate myMouseRotate = new MouseRotate();
        myMouseRotate.setTransformGroup(objTransform);
        myMouseRotate.setSchedulingBounds(new BoundingSphere());
        objroot.addChild(myMouseRotate);
		
        MouseTranslate myMouseTranslate = new MouseTranslate();
        myMouseTranslate.setTransformGroup(objTransform);
        myMouseTranslate.setSchedulingBounds(new BoundingSphere());
        objroot.addChild(myMouseTranslate);

        MouseZoom myMouseZoom = new MouseZoom();
        myMouseZoom.setTransformGroup(objTransform);
        myMouseZoom.setSchedulingBounds(new BoundingSphere());
        objroot.addChild(myMouseZoom);						
       
        objTransform.addChild(createGraph());
		objroot.addChild(createBackground());
        objroot.addChild(createLights());
                
	    enablePicking(objroot);
	    objroot.compile();
		
		return objroot;
	}
	/**
	 * Oppretter kulene og koblingene til grafen
	 * 
	 * @return Tre som inneholder nodene som skal visualiseres
	 */
	public BranchGroup createGraph()
	{
		BranchGroup branchgroup = new BranchGroup();
		Appearance appcylinder = new Appearance();
		Appearance appcylinder1 = new Appearance();
		Appearance appcylinder2 = new Appearance();
		Appearance appcylinder3 = new Appearance();
		
		defaultapp = new Appearance();
		alternativeapp = new Appearance();
		
		EqualityMatrix equalitymatrix;
		equalitymatrix = filereader.getEqualityMatrix();
				
		Color3f alternativecolor = new Color3f(1.0f, 1.0f, 0.0f);
		Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
		
		defaultapp.setMaterial(new Material(defaultcolor, black, defaultcolor, black, 80f));
		alternativeapp.setMaterial(new Material(alternativecolor, black, alternativecolor, black, 80f));
		
		appcylinder.setMaterial(new Material(defaultcolor, black, defaultcolor, black, 80f));
				
		TransparencyAttributes t_attr =
			   new TransparencyAttributes(TransparencyAttributes.FASTEST,1.0f);
		
		t_attr.setTransparency(TRANS);
		appcylinder.setTransparencyAttributes( t_attr );
		
		for(int index1 = 0; index1 < documentitemlist.size(); index1++)
		{
						
			Sphere sphere = new Sphere(sizeofspheres, Primitive.GENERATE_NORMALS |Sphere.ENABLE_APPEARANCE_MODIFY|Sphere.GENERATE_TEXTURE_COORDS , 32, defaultapp);
			TransformGroup tg = new TransformGroup();
			TransformGroup tg2 = new TransformGroup();
			Transform3D transform = new Transform3D();

			DocumentItem node = (DocumentItem)documentitemlist.get(index1);
			sphere.setUserData(node);
						
			Vector3f vector = new Vector3f(node.getPosx(), node.getPosy(), node.getPosz());
			transform.setTranslation(vector);
	
			tg.setTransform(transform);
			tg.addChild(sphere);
			branchgroup.addChild(tg);

			Transform3D translate2 = new Transform3D();
			translate2.set(new Vector3f(node.getPosx(), node.getPosy()+0.20f, node.getPosz())); // Var: 0.1f
			TransformGroup objText = new TransformGroup(translate2);
		
			String[] array =node.getDocumentStrings();
			String name=array[0];
			Text2D text = new Text2D(name, new Color3f(0.0f,0.0f,0.0f),
			   "Verdana", 18, Font.BOLD);
			objText.addChild(text);
			objText.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
			objText.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
			 
			tg2.addChild(objText);
			tg2.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
			tg2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
			  
			BoundingSphere bounds =
			    new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
						  
			Billboard bb = new Billboard(tg2, Billboard.ROTATE_ABOUT_POINT,
				         new Point3f(node.getPosx(), node.getPosy(), node.getPosz()));
				      bb.setSchedulingBounds(bounds);
	      
			tg2.addChild(bb); 
	      
			branchgroup.addChild(tg2);
				
			for(int index2 = 0; index2 < node.getSize(); index2++)
			{
				DocumentItem koblingsnode;
				koblingsnode =(DocumentItem)node.getConnectionNode(index2);
								
				
				CylinderCreator cylinder = new CylinderCreator();
				Point3d p1 = new Point3d((double)node.getPosx(), (double)node.getPosy(), (double)node.getPosz());
				Point3d p2 = new Point3d((double)koblingsnode.getPosx(), (double)koblingsnode.getPosy(), (double)koblingsnode.getPosz());
				cylinder.setResolution(32);
				Color3f soft = new Color3f(0.0f, 1.0f, 0.0f);
				Color3f medium = new Color3f(1.0f, 1.0f, 0.0f);
				Color3f Strong = new Color3f(1.0f, 0.3f, 0.3f);
		//		System.out.println(equalitymatrix.getEquality(index1,index2));

				int i1 =index1;
				int i2=	koblingsnode.getindeks();
				
				if(equalitymatrix.getEquality(i1,i2)>0.70f)
				{
					appcylinder1.setMaterial(new Material(Strong, black, Strong, black, 80f));	
		//			System.out.println("Strong "+equalitymatrix.getEquality(i1,i2) +" index1= "+i1+" index2= " +i2);
					TransformGroup tgcyl = cylinder.create(p1, p2, sizeofcylinders, appcylinder1);			
					branchgroup.addChild(tgcyl);
				}
				else if(equalitymatrix.getEquality(i1,i2)>0.55f)
				{
	//				System.out.println(medium "+equalitymatrix.getEquality(i1,i2)+"index1= "+i1+" index2= " +i2);
					appcylinder2.setMaterial(new Material(medium, black, medium, black, 80f));
					TransformGroup tgcyl = cylinder.create(p1, p2, sizeofcylinders, appcylinder2);
					branchgroup.addChild(tgcyl);
				}
				else if(equalitymatrix.getEquality(i1,i2)>0.30f)
				{
	//				System.out.println("soft "+equalitymatrix.getEquality(i1,i2)+"index1= "+i1+" index2= " +i2);
					appcylinder3.setMaterial(new Material(soft, black, soft, black, 80f));
					TransformGroup tgcyl = cylinder.create(p1, p2, sizeofcylinders, appcylinder3);
					branchgroup.addChild(tgcyl);
				}
				
			}
			
		}

		return branchgroup;
		
	}

	/**
	 * Oppretter lys til scenen
	 * 
	 * 
	 * @return gruppe som legges til scenen
	 */
	public BranchGroup createLights()
	{
		BranchGroup branchgroup = new BranchGroup();	
		Color3f light1Color = new Color3f(1.0f, 1.0f, 1.0f);

		BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
		Vector3f light1Direction = new Vector3f(4.0f, -7.0f, -12.0f);
		DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);

		light1.setInfluencingBounds(bounds);
		branchgroup.addChild(light1);	
		
		return branchgroup;
	}
	/**
	 * Oppretter bakgrunnen til scenen
	 * 
	 * @return gruppe som legges til scenen
	 */
	public BranchGroup createBackground()
	{
		BranchGroup branchgroup = new BranchGroup();
				
		if(!showsky)
		{
			Background bg = new Background();
			bg.setColor(0.6f, 0.7f, 0.9f);
			bg.setApplicationBounds(new BoundingSphere());
			
			branchgroup.addChild(bg); 
		
		}
		else
		{
			TextureLoader bgtexture = new TextureLoader("newsky.jpg", null);
			
			Background bgimage = new Background(bgtexture.getImage());
			BoundingSphere	infinitebounds = new BoundingSphere(new Point3d(),
						Double.MAX_VALUE);	
					
			bgimage.setApplicationBounds(infinitebounds);
			branchgroup.addChild(bgimage);
	
			Background bggeo = new Background();
			bggeo.setApplicationBounds(infinitebounds);
			BranchGroup bgGeoBG = new BranchGroup();
			Appearance bgGeoApp = new Appearance();
			bgGeoApp.setTexture(bgtexture.getTexture());
		    Sphere sphereObj = new Sphere(1.0f,
						  Sphere.GENERATE_NORMALS |
		                                  Sphere.GENERATE_NORMALS_INWARD |
		                                  Sphere.GENERATE_TEXTURE_COORDS,
						  45, bgGeoApp);
		    bgGeoBG.addChild(sphereObj);
		    bggeo.setGeometry(bgGeoBG);
		    branchgroup.addChild(bggeo);
			
		}
		
		return branchgroup;

	}
	/**
	 * Metode som hndterer menyvalg. den menyvalget som blir valgt
	 * inneholder en streng som sjekkes mot arrayet til noden som ble 
	 * hyreklikket p 
	 * 
	 * @param actionevent
	 */
	public void menuAction(ActionEvent actionevent)
	{
		if(actionevent.getSource()== tmpmenuitem)
		{
			FileLauncher.openURL(nameoftestmap+"/"+"Dok/"+urlarray[0]);
		}
		
	}
	public void showFrekvens()
	{
		
		if(frekvensbilde)
		{
			changeColorsOnNodes(objroot,false);
			frekvensbilde=false;
		}
		else
		{
			changeColorsOnNodes(objroot,true);
			frekvensbilde= true;
		}
		
		nodenr=0;
		
	}
	public void setFrekensLimits(int limit)
	{
		frekvenslimit= limit;

	}
	public void changeColorsOnNodes(Node node, boolean frekvensfarge)
	{
		Appearance appcylinder1 = new Appearance();
		Appearance appcylinder2 = new Appearance();
		Appearance appcylinder3 = new Appearance();
		Appearance appcylinder4 = new Appearance();
		
		Color3f darkred= new Color3f(0.7f, 0.0f, 0.0f);
		Color3f red= new Color3f(1.0f, 0.0f, 0.0f);
		Color3f green= new Color3f(0.0f, 1.0f, 0.0f);
		Color3f darkgreen= new Color3f(0.0f, 0.6f, 0.0f);
		Color3f black= new Color3f(0.0f, 0.0f, 0.0f);
		
		appcylinder1.setMaterial(new Material(darkred, black, darkred, black, 80f));
		appcylinder2.setMaterial(new Material(red, black, red, black, 80f));
		appcylinder3.setMaterial(new Material(darkgreen, black, darkgreen, black, 80f));
		appcylinder4.setMaterial(new Material(green, black, green, black, 80f));
		
		if(node instanceof Sphere)
		{
		
			Primitive primitive = (Primitive)node;
			tmpdocumentitem=(DocumentItem)primitive.getUserData();

			if(frekvensfarge)
			{
				if(frekvenslimit==1)
				{
				
					if(frekvensarray[nodenr]==0)
					{
						 primitive.setAppearance(appcylinder1);
					}
					if(frekvensarray[nodenr]>0)
					{
						primitive.setAppearance(appcylinder2);
					}
					if(frekvensarray[nodenr]>2)
					{
						primitive.setAppearance(appcylinder3);
					}
					if(frekvensarray[nodenr]>5)
					{
						primitive.setAppearance(appcylinder4);
					}
					
				}
				else if(frekvenslimit==2)
				{
					
					if(frekvensarray[nodenr]==0)
					{
						 primitive.setAppearance(appcylinder1);
					}
					if(frekvensarray[nodenr]>0)
					{
						primitive.setAppearance(appcylinder2);
					}
					if(frekvensarray[nodenr]>5)
					{
						primitive.setAppearance(appcylinder3);
					}
					if(frekvensarray[nodenr]>8)
					{
						primitive.setAppearance(appcylinder4);
					}
					
				}				
				else if(frekvenslimit==3)
				{
					
					if(frekvensarray[nodenr]==0)
					{
						 primitive.setAppearance(appcylinder1);
					}
					if(frekvensarray[nodenr]>0)
					{
						primitive.setAppearance(appcylinder2);
					}
					if(frekvensarray[nodenr]>6)
					{
						primitive.setAppearance(appcylinder3);
					}
					if(frekvensarray[nodenr]>12)
					{
						primitive.setAppearance(appcylinder4);
					}
					
				}
				
				nodenr++;
							
			}
			else
			{
				primitive.setAppearance(defaultapp);
			
			}
			
		}
	    try
	    { 

	       Group group = (Group) node; 

	       for (Enumeration e = group.getAllChildren(); e.hasMoreElements();)
	       { 
	    	   changeColorsOnNodes((Node)e.nextElement(),frekvensfarge); 
	       } 
	       
	    } 
	    catch(ClassCastException exception)
	    { 
//	    	System.out.println(exception);
	    } 
		
	}
	
	/**
	 * Metoden gr gjennom alle mulige greiner fra noden som spesifiseres(node tre)
	 * for alle instanser av Sphere gjres disse objektene "klikkbare"
	 * Dette gjres for  kunne velge kuler basert p geometien til nodene 
	 * Alternativet hadde vrt  velge kuler basert p bounds som er veldig unyaktig
	 *  
	 * @param node
	 */
	public void settAllCylindersInvisible(Node node, boolean invisible)
	{
				
		if(node instanceof Sphere)
		{
			Primitive primitive = (Primitive)node;
			tmpdocumentitem=(DocumentItem)primitive.getUserData();
			count=0;
		}
						
		if(node instanceof Cylinder)
		{
			
			DocumentItem b= (DocumentItem)tmpdocumentitem.getConnectionNode(count);
			count++;
			Primitive primitive = (Primitive)node;
		
			int i1 =tmpdocumentitem.getindeks();
			int i2=	b.getindeks();
			Appearance appcylinder1 = new Appearance();
			Appearance appcylinder2 = new Appearance();
			Appearance appcylinder3 = new Appearance();
			
			Color3f soft= new Color3f(0.0f, 1.0f, 0.0f);
			Color3f medium= new Color3f(1.0f, 1.0f, 0.0f);
			Color3f Strong= new Color3f(1.0f, 0.3f, 0.3f);
			Color3f black= new Color3f(0.0f, 0.0f, 0.0f);
			
			if(equalitymatrix.getEquality(i1,i2)>0.70f)
			{
				appcylinder1.setMaterial(new Material(Strong, black, Strong, black, 80f));	

				TransparencyAttributes t_attr =
					   new TransparencyAttributes(TransparencyAttributes.FASTEST,1.0f);
				if(invisible == true)
				{
					t_attr.setTransparency(1.0f);
				}
				else
				{
					t_attr.setTransparency(TRANS);
				}
				
				appcylinder1.setTransparencyAttributes( t_attr );
				primitive.setAppearance(appcylinder1);	
							
				
			}
			else if(equalitymatrix.getEquality(i1,i2)>0.55f)
			{
		//		System.out.println("medium "+equalitymatrix.getEquality(i1,i2)+"index1= "+i1+" index2= " +i2);
				appcylinder2.setMaterial(new Material(medium, black, medium, black, 80f));

				TransparencyAttributes t_attr =
					   new TransparencyAttributes(TransparencyAttributes.FASTEST,1.0f);
				if(invisible == true)
				{
					t_attr.setTransparency(1.0f);
				}
				else
				{
					t_attr.setTransparency(TRANS);
			}
				
				appcylinder2.setTransparencyAttributes( t_attr );
				primitive.setAppearance(appcylinder2);				
					
				
			}
			else if(equalitymatrix.getEquality(i1,i2)>0.30f)
			{
		//		System.out.println("rd "+equalitymatrix.getEquality(i1,i2)+"index1= "+i1+" index2= " +i2);
				appcylinder3.setMaterial(new Material(soft, black, soft, black, 80f));

				TransparencyAttributes t_attr =
					   new TransparencyAttributes(TransparencyAttributes.FASTEST,1.0f);
				if(invisible == true)
				{
					t_attr.setTransparency(1.0f);
				}
				else
				{
					t_attr.setTransparency(TRANS);
				
				}
				
				appcylinder3.setTransparencyAttributes( t_attr );
				primitive.setAppearance(appcylinder3);			
						
			}			
						
		}
		try
	    { 

	       Group group = (Group) node; 

	       for (Enumeration e = group.getAllChildren(); e.hasMoreElements();)
	       { 
	    	   settAllCylindersInvisible((Node)e.nextElement(),invisible); 
	       } 

	    } 
	    catch(ClassCastException exception)
	    { 
//	    	System.out.println(exception);
	    } 

	}
	/**
	 * Setter alle kantene synlig rundt den noden som er valgt
	 * 
	 * @param node
	 */
	public void settSelectedNodesCylindersVisible(Node node)
	{
		if(node == tmpobjekt)
		{
			showcylinders = true;
				
		}
		if(showcylinders)
		{
			if(node != tmpobjekt)
			{
				if(node instanceof Sphere)
				{
					showcylinders = false;
				}
			}

			if(node instanceof Cylinder)
			{
				Primitive primitive = (Primitive)node;
				
				Appearance appcylinder = new Appearance();
			
				Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
				appcylinder.setMaterial(new Material(defaultcolor, black, defaultcolor, black, 80f));
						
				TransparencyAttributes t_attr =
						   new TransparencyAttributes(TransparencyAttributes.FASTEST,1.0f);
				t_attr.setTransparency(TRANS);
					
				appcylinder.setTransparencyAttributes( t_attr );
				primitive.setAppearance(appcylinder);
				
			}
		}
		
	    try
	    { 

	       Group group = (Group) node; 

	       for (Enumeration e = group.getAllChildren(); e.hasMoreElements();)
	       { 
	    	   settSelectedNodesCylindersVisible((Node)e.nextElement()); 

	       } 

	    } 
	    catch(ClassCastException exception)
	    { 
//	    	System.out.println(exception);
	    }
		
	}
	/***
	 * Setter nodene klikkbare og setter bits som gjr at man kan lese
	 * barna til gruppene.
	 * 
	 * @param node
	 */
	public void enablePicking(Node node)
	{ 
		
		node.setCapability(Group.ALLOW_CHILDREN_READ);
		
		if(node instanceof Sphere)
		{
		    node.setPickable(true); 
		    node.setCapability(Node.ENABLE_PICK_REPORTING);
		   
		}
		
	    try
	    { 

	       Group group = (Group) node; 

	       for (Enumeration e = group.getAllChildren(); e.hasMoreElements();)
	       { 
	          enablePicking((Node)e.nextElement()); 
	         
	       } 

	       
	    } 
	    catch(ClassCastException exception)
	    { 
//	    	System.out.println(exception);
	    } 
	    
	    try
	    { 
	          Shape3D shape = (Shape3D) node; 
	          PickTool.setCapabilities(node, PickTool.INTERSECT_FULL); 

	    } 
	    catch(ClassCastException exception)
	    { 	    	
//	    	System.out.println(exception);
	    } 

	}	
/**
 * Metode som hndterer alt som har med museklikk  gjre. hyeklikking av node bringer fra popup meny som tilater  vise rssurs
 * hndterer ogs zoming,skalering og forteller programet nr det skal vises skjules kanter.
 * 
 */
	public void mouseClicked(MouseEvent event)
	{
		if((event.getModifiers() & InputEvent.BUTTON1_MASK) !=0)
		{
			if(frekvensbilde)
			{
				
			}
			else
			{
				pickCanvas.setShapeLocation(event); 
			    PickResult result = pickCanvas.pickClosest(); 
			   
			    if (result == null)
			    {
			    	settAllCylindersInvisible(objroot, false);
			    	showsylinderspicked = true;
			    	if(objektpicked == true)
			    	{
			    		tmpobjekt.setAppearance(defaultapp);
			    		objektpicked=false;
			    	}
			 
			    }
			    else
			    { 


			       Primitive primitive = (Primitive)result.getNode(PickResult.PRIMITIVE); 
			       
			       if(primitive instanceof Sphere)
			       {
			    		    	   

			    	   
			    	   DocumentItem tempdoc =(DocumentItem)primitive.getUserData();
			    	   int stackint =tempdoc.getindeks();

			 	    	   
			    	   objektpicked = true;

			       	   tmpobjekt = primitive;
			       	   settAllCylindersInvisible(objroot, true);
			       	   settSelectedNodesCylindersVisible(objroot);
  

			       }//end if instanceof sphere
		   	    
			    }
		    
			}
				
		}
		else if((event.getModifiers() & InputEvent.BUTTON2_MASK) !=0)
		{

		}
		else if((event.getModifiers() & InputEvent.BUTTON3_MASK) !=0)
		{
			if(frekvensbilde)
			{
				
			}
			else
			{
				pickCanvas.setShapeLocation(event); 
			    PickResult result = pickCanvas.pickClosest(); 
			   
			    if (result == null)
			    {
			    	settAllCylindersInvisible(objroot, false);
			    	showsylinderspicked = true;
		//	    	if(objektpicked == true)
		//	    	{
			    		tmpobjekt.setAppearance(defaultapp);
			    		objektpicked=false;
			//    	}
			 
			    }
			    else
			    { 


			       Primitive primitive = (Primitive)result.getNode(PickResult.PRIMITIVE); 
			       
			       if(primitive instanceof Sphere)
			       {
			    		    	   
			    	   if(objektpicked)
			    	   {
						   tmpobjekt.setAppearance(defaultapp);
			    	   }
			    	   
			    	   DocumentItem tempdoc =(DocumentItem)primitive.getUserData();
			    	   int stackint =tempdoc.getindeks();
			    	   StackNode tmp = new StackNode();
			    	   tmp.setNodeNr(stackint);
			    	   totalhistory.add(tmp);
			    	   stack1.add(tmp);
			    	   
			    	   int tempint= frekvensarray[tempdoc.getindeks()];
			    	   tempint++;
			    	   frekvensarray[tempdoc.getindeks()]= tempint;
			 	    	   
			    	   objektpicked = true;
			    	   primitive.setAppearance(alternativeapp);
			       	   tmpobjekt = primitive;
		   		       	   
			       	   DocumentItem data=(DocumentItem)primitive.getUserData();
				       if(data != null)
					   {
						   if(multidocuments)
						   {
							   nodemeny.removeAll();
							   
							   urlarray = data.getDocumentStrings();
						   					   
							   addMenuItems(urlarray);//oppretter meny til noden
					
							   nodemeny.show(event.getComponent(), event.getX(), event.getY());
						   }
						   
					   }

			       }//end if instanceof sphere
		   	    
			    }
		    
			}
			
		}
	}
	/**
	 * Legger til "menyknapper" til popup menyen basert p en tabell
	 * over URLer.
	 * 
	 * @param urlarray
	 */
	public void addMenuItems(String[] urlarray)
	{

			tmpmenuitem = new MenuItem("pne dokument");
			nodemeny.add(tmpmenuitem);
		  	tmpmenuitem.addActionListener(new ActionListener(){
		    	 public void actionPerformed(ActionEvent ae){
		    		  menuAction(ae);}});
 
	}
	/**
	 * Finn den speisifserte noden og sett den spesifiserte apperance p denne noden
	 * 
	 * @param node som skal foranfre utseende
	 * @param nodetoshow verid for  finne riktig node
	 * @param app utsendeinformasjon som skal settes p noden
	 */
	public void setNode(Node node, int nodetoshow, Appearance app)
	{
	

		
			if(node instanceof Sphere)
			{
				Primitive primitive = (Primitive)node;
				tmpdocumentitem=(DocumentItem)primitive.getUserData();
				int indeks=tmpdocumentitem.getindeks();
				if(indeks==nodetoshow)
				{
					primitive.setAppearance(app);
				}
			
			}
							
	    try
	    { 

	       Group group = (Group) node; 

	       for (Enumeration e = group.getAllChildren(); e.hasMoreElements();)
	       { 
	    	   setNode((Node)e.nextElement(),nodetoshow, app); 

	       } 

	    } 
	    catch(ClassCastException exception)
	    { 
//	    	System.out.println(exception);
	    }
		
	}
	/**
	 * Hjelpemetode for hndtere knapp valget g tilbake. gr tilbake til forrige node
	 * og oppdaterer stack informasjon.
	 *
	 */
	public void goBack()
	{
	
		if(stack1.size()>1)
		{
		
			if(showsylinderspicked==true)
			{
				StackNode tmp = (StackNode)stack1.getLast();
				setNode(objroot,tmp.getNodeNr(),alternativeapp);
				showsylinderspicked=false;
				
			}
			else
			{
	
				StackNode tmp = (StackNode)stack1.getLast();
				setNode(objroot,tmp.getNodeNr(),defaultapp);
			
				stack2.add(tmp);
				stack1.removeLast();
					
				tmp = (StackNode)stack1.getLast();
				setNode(objroot,tmp.getNodeNr(),alternativeapp);
				
			}
			
		}
		else if(stack1.size()==1)
		{
			
			if(showsylinderspicked==true)
			{
				StackNode tmp = (StackNode)stack1.getLast();
				setNode(objroot,tmp.getNodeNr(),alternativeapp);
				showsylinderspicked = false;
				
			}
			else
			{
				
				StackNode tmp = (StackNode)stack1.getLast();
				setNode(objroot,tmp.getNodeNr(),defaultapp);
		
				stack2.add(tmp);
				stack1.removeLast();
				
			}
			// DO nothing
			
		}
		else if(stack1.size()==0)
		{
		}

	}
	/**
	 * Hjelpemetode for  hndtere knapp valget g framover. gr framover til tidligere node
	 * fungerer p samme vis som forward knappen i nettlesere
	 * og oppdaterer stack informasjon.
	 * 
	 *
	 */
	public void goForward()
	{
		
		if(stack2.size()>1)
		{

			StackNode tmp = (StackNode)stack2.getLast();
			setNode(objroot,tmp.getNodeNr(),alternativeapp);

			if(stack1.size()>0)
			{

				StackNode tmp1;
				tmp1 = (StackNode)stack1.getLast();
				setNode(objroot,tmp1.getNodeNr(),defaultapp);

			
			
			}
			stack1.add(tmp);
			stack2.removeLast();

			
		}
		else if(stack2.size()==1)
		{
			
			StackNode tmp = (StackNode)stack2.getLast();
			setNode(objroot,tmp.getNodeNr(),alternativeapp);
			
			if(stack1.size()>0)
			{

				StackNode tmp1; 
				tmp1 = (StackNode)stack1.getLast();
				setNode(objroot,tmp1.getNodeNr(),defaultapp);

			}
			
			stack1.add(tmp);
			stack2.removeLast();	
			
		}
		else if(stack1.size()==0)
		{
		}

	}
	/**
	 * Hjelpemetode for  lagre frekvensdata til fil
	 * 
	 */
	public void saveFrekdata()
	{
		filereader.writeFrekdata(frekvensarray, nameoftestmap);
	}
	/**
	 * Sletter den gjeldende historie informasjonene og leser inn ny histore informasjon fra fil
	 * 
	 * 
	 * @param filename navnet p filen der historie informasjonen ligger
	 */
	public void openNodeHistory(String filename)
	{
		totalhistory =filereader.openBrowseHistory(filename);
		stack1.clear();
		stack2.clear();
		
		for(int i=0;i<totalhistory.size();i++)
		{
			StackNode a =(StackNode)totalhistory.get(i);
			stack2.addFirst(a);
		}
		
	}
	/**
	 * Lagrer sesjons historien til det valget filnanvnet
	 * 
	 * @param filename navnet p filen der browse historien skal lagres
	 */
	public void saveNodeHistory(String filename)
	{
		filereader.saveBrowseHistory(filename,totalhistory);
		totalhistory.clear();
		
	}
	/**
	 * Fjerner nvrende browsehistorie
	 * 
	 *
	 */
	public void resetBrowseHistory()
	{
		stack1.clear();
		stack2.clear();
		totalhistory.clear();
	}
	
	public void mousePressed(MouseEvent event){}
	public void mouseReleased(MouseEvent event){}
	public void mouseEntered(MouseEvent event){}
	public void mouseExited(MouseEvent event) {}
	
}//end class Gui

