import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.universe.SimpleUniverse;
import java.io.*;
/**
 * Klassen har som oppgave  opprette kanvas som inneholder 3D logikken
 * og oppretter meny/knapper og utfrer kode i forhold til eventuelle
 * meny/knapp valg
 * 
 * @author Ole Kristian Hvaale, 1. Februar 2006 
 *-----------------------------------------------------
 * Sist oppdatert: 2006/5/11
 * av: Ole Kristian Hvaale
 * Endringer: lagt til kode for nye knapper. visning av frekvensbilde og
 * fram og tilbake knapper.
 *
 */

public class PaintFrame extends JFrame
{
	private JMenuItem 	open,reset, save, frekvensdata;
	private JMenuBar menubar;
	private JPanel appPanel;
	private Gui canvas3D;
	private JLabel colorpic,infopic;
	
	private JButton backbutton;
	private JButton forwardbutton;
	private JButton frekvenspicture;
	private JButton exitbutton;
	
	private final JFileChooser filechooser = new JFileChooser();
	private final JFileChooser filechooser2 = new JFileChooser();
	String testdata= null;
	/**
	 *  Kostruktren til PaintFrame klassen
	 *	oppretter menyen kanvasen og legger disse til et panel
	 *	strrelse og plassering av elementene blir ogs utfrt i konstruktrmetoden
	 */
	public PaintFrame ()
	{
		super ("Java3D");
	
		addComponentListener (new ComponentResized());
		ExampleFileFilter filter = new ExampleFileFilter();
	    filter.addExtension("Path");
	    
	    filter.setDescription("Path files");
	    filechooser.setFileFilter(filter);
			
		chooseStartData();
		boolean showsky = false;
		showsky = showBackGroundPicture();
		float threshold =chooseThresholdValue();
	
		GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
		ButtonListener listener = new ButtonListener();
		menubar = createMenuBar();
		canvas3D = new Gui( config, testdata, threshold, showsky);
		appPanel = new JPanel();
		ImageIcon icon = new ImageIcon("farger.gif");
		ImageIcon icon2 = new ImageIcon("frekvinfo.jpg");
		colorpic = new JLabel(icon);
		colorpic.setToolTipText("Information about edges in the graph");
		
		infopic = new JLabel(icon2);
		infopic.setToolTipText("Explanation of node colors in frequence picture");
		
		backbutton = new JButton(new ImageIcon("left.gif"));
		backbutton.setPressedIcon(new javax.swing.ImageIcon("left_p.gif"));
		backbutton.addActionListener (listener);
		backbutton.setToolTipText("Takes you to the previous node");
		
		forwardbutton = new JButton(new ImageIcon("right.gif"));
		forwardbutton.setPressedIcon(new javax.swing.ImageIcon("right_p.gif"));
		forwardbutton.addActionListener (listener);
		forwardbutton.setToolTipText("Takes you to the next node");
		
		exitbutton = new JButton(new ImageIcon("exit.gif"));
		exitbutton.setPressedIcon(new javax.swing.ImageIcon("exit_p.gif"));
		exitbutton.addActionListener (listener);
		exitbutton.setToolTipText("Exit the application and saves the frequencedata");
		
		frekvenspicture = new JButton(new ImageIcon("frek.jpg"));
		frekvenspicture.addActionListener (listener);
		frekvenspicture.setToolTipText("Transforms the graph to show frequencedata");
				
		appPanel.setLayout(null);
		appPanel.add(menubar);
		appPanel.add(canvas3D);
		appPanel.add(colorpic);
		appPanel.add(infopic);
		appPanel.add(backbutton);
		appPanel.add(forwardbutton);
		appPanel.add(frekvenspicture);
		appPanel.add(exitbutton);
		appPanel.setBackground(Color.lightGray);
		int buttonsize=40;
		
		canvas3D.setBounds(0,80,1024,717);
		menubar.setBounds(0,0,100,25);
		colorpic.setBounds(100,0,171,80);
		backbutton.setBounds(280,20,buttonsize,buttonsize);
		forwardbutton.setBounds(330,20,buttonsize,buttonsize);
		exitbutton.setBounds(380,20,buttonsize,buttonsize);
		frekvenspicture.setBounds(700,20,buttonsize,buttonsize);
		
		infopic.setBounds(450,0,216,80);
		menubar.setFont(new Font("Serif",Font.BOLD,100));
		appPanel.setPreferredSize(new Dimension(1024,768));
		
		addWindowListener (new WindowCloser());
	
		setContentPane (appPanel);

	}
	/**
	 * pner opp et Joption panel som lar brukern gi inn en terskelverdi som skal brukes i programmet
	 * 
	 * @return Terskelverdien brukern har valgt
	 */
	public float chooseThresholdValue()
	{
		String inputValue = JOptionPane.showInputDialog("Please input a number from [0-100] (0 equals no connections) Default is 55");
		
		float value=0;
		float threshold =0;
		try
		{
			value = Integer.parseInt(inputValue);
			if(value>70)
			{
				threshold=0.3f;
			}
			else
			{
				threshold = (float)(100-value)/100;
			}
			if(value<0 ||value>100)
			{
				threshold =0.45f;
				
			}
		}
		catch (NumberFormatException e)
		{
			// TODO Auto-generated catch block
			//e.printStackTrace();
			System.out.println("Not valid number using default value");
			threshold = 0.45f;
		}

		System.out.println(threshold);
		return threshold;
		
	}
	/**
	 *	pner filechooser slik at brukern kan velge hvilket kunskapsbase som skal visualiseres
	 *	
	 */
	public void chooseStartData()
	{
		ExampleFileFilter filter = new ExampleFileFilter();
	    filter.addExtension("java3d");
	    filter.setDescription("Java3d application files");
	    filechooser2.setFileFilter(filter);

	    File opendirectory = new File("."+"/"+"testdata");
		filechooser2.setCurrentDirectory(opendirectory);
	
		int returnValue = filechooser2.showOpenDialog(null);
		

		if(returnValue == JFileChooser.APPROVE_OPTION)
		{
			File fil = filechooser2.getSelectedFile();
		//	testdata = fil.getAbsolutePath();
			File a =fil.getParentFile();
	//		File b = fil.getAbsoluteFile();
	
		     String ext = null;
		       String s = fil.getName();
		       int i = s.lastIndexOf('.');

		        if (i > 0 &&  i < s.length() - 1) {
		            ext = s.substring(i+1).toLowerCase();
		        }
		       System.out.println(ext); 
		    if(ext.compareTo("java3d")==0)
		    {
		    	System.out.println("er java3d");
		    	testdata=a.toString();
		    }
		    else
		    {
		    	testdata = "." +"\\testdata\\19dokumenter";
		    }
		    
		    System.out.println(testdata);
		
		}		
		
	}
	/**
	 * Metode som gir brukeren mulighet til  bestemme om bakgrunnen skal
	 * vre et bilde som illustrerer skyer
	 * 
	 * @return boolean som bestemmer om bildet skal vises eller ikke
	 */
	public boolean showBackGroundPicture()
	{
		boolean show = true;
		Object[] options = {"Ja",
                "Nei"};
		int n = JOptionPane.showOptionDialog(this,
				"Vil du bruke skyer som bakgrunn?"
				+ "",
				"Innstilling av bakgrunn",
				JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				null,
				options,
				options[1]);
		if(n==0)
		{
			show= true;
		}
		else if(n==1)
		{
			show= false;
		}
		return show;
	}
	/**
	 *  Oppretter menyer og menyvalg
	 *  Legger menyvalgene til menyen og returnerer en JMenuBar
	 * 
	 */
	private JMenuBar createMenuBar()
	{
		MenuListener menulistener = new MenuListener();
		
		JMenu filemenu = new JMenu ("File");
		JMenu settingsmenu = new JMenu ("Settings");
	//	JMenu newmenu = new JMenu ("Options");
	
		open = new JMenuItem ("Open Path");
		open.addActionListener (menulistener);
		open.setToolTipText ("Open saved Node path");
		
		save = new JMenuItem ("Save Path");
		save.addActionListener (menulistener);
		save.setToolTipText ("Saves the current browse history");
		
		
		frekvensdata = new JMenuItem ("Frequence data");
		frekvensdata.addActionListener (menulistener);
		frekvensdata.setToolTipText ("Modifies the values in frekvens picture");
		
		reset = new JMenuItem ("Reset");
		reset.addActionListener (menulistener);
		reset.setToolTipText ("Reset the Browse history in this sesion");
	
		filemenu.add (open);
		filemenu.add (save);
		
		settingsmenu.add(frekvensdata);
		settingsmenu.add (reset);
		
		JMenuBar bar = new JMenuBar();
		bar.add (filemenu);
		bar.add(settingsmenu);
	
		return bar;
	}
	/**
	 * Indre klasse som utfrer kode i forhold til de menyvalgene
	 * brukeren velger
	 *
	 */
	private class ButtonListener implements ActionListener
	{
		//--------------------------------------------------------------
		//  Responds to action events caused by buttons.
		//--------------------------------------------------------------
		public void actionPerformed (ActionEvent event)
		{
			Object source = event.getSource();
			
			if (source == backbutton)
			{
			//	System.out.println("RUNNNNNNNNNN");
				canvas3D.goBack();
			}
			else if(source == forwardbutton)
			{
				canvas3D.goForward();
			//	System.out.println("FORWARD MARCH");
			}
			else if(source == frekvenspicture)
			{
				canvas3D.showFrekvens();
			//	System.out.println("FORWARD MARCH");
			}		
			else if(source == exitbutton)
			{
				canvas3D.saveFrekdata();
				System.exit(0);
			}
		
			
		}
	}
		
	private class MenuListener implements ActionListener
	{
		public void actionPerformed (ActionEvent event)
		{
			Object source = event.getSource();
			
			if(source == save)
			{
				System.out.println(testdata+"\\"+"path");
				filechooser.setCurrentDirectory(new File(testdata+"\\"+"path"));
				int returnValue = filechooser.showSaveDialog(null);
				
				if(returnValue == JFileChooser.APPROVE_OPTION)
				{
					File fil = filechooser.getSelectedFile();
					String fileSave = fil.getAbsolutePath();
					canvas3D.saveNodeHistory(fileSave);
				}
				//benyttet til  teste klassen FileLauncher
			//	FileLauncher.openURL("http://www.vg.no/");
				
			}
			else if(source == open)
			{
				filechooser.setCurrentDirectory(new File(testdata+"\\"+"path"));
				int returnValue = filechooser.showOpenDialog(null);
				
				if(returnValue == JFileChooser.APPROVE_OPTION)
				{
					File fil = filechooser.getSelectedFile();
					String fileOpen = fil.getAbsolutePath();
					canvas3D.openNodeHistory(fileOpen);
				}
				// kun for  teste reset til stacken, vil flytte denne
		
				
			}	
			else if(source == reset)
			{
				canvas3D.resetBrowseHistory();
			}			
		
			else if (source == frekvensdata)
			{
				Object[] possibleValues = { "Dark red = 0, red = [1-2], dark green = [3-5], green = [6+] ", "Dark red = 0, red = [1-5], dark green = [6-8], green = [9+]", "Dark red = 0, red = [1-6], dark green = [7-12], green = [13+]" };
				Object selectedValue = JOptionPane.showInputDialog(null, 
				"Modify when colors will switch in frekvenspicture", "Input",
				JOptionPane.INFORMATION_MESSAGE, null,
				possibleValues, possibleValues[0]);
				try
				{
					if(selectedValue.equals(possibleValues[0]))
					{
						System.out.println("frekvensdata1");
						canvas3D.setFrekensLimits(1);
					}
					else if(selectedValue.equals(possibleValues[1]))
					{
						System.out.println("frekvensdata2");
						canvas3D.setFrekensLimits(2);
					}
					else if(selectedValue.equals(possibleValues[2]))
					{
						System.out.println("frekvensdata3");
						canvas3D.setFrekensLimits(3);
					}
		
				}
				catch(Exception e)
				{
					
				}
						
			}
		}
		
	}
	/**
	 * Indre klasse som srger for at konsolvinduet blir riktig avsluttet
	 * med kall til metoden System.exit(0) s srger man for 
	 * avslutte JVM.
	 * Konsolvinduet ikke st  henge hvis JVM er riktig avsluttet.
	 */
	private class WindowCloser extends WindowAdapter
	{
		//Avslutter programmet riktig ved  avslutte JVM
		public void windowClosing (WindowEvent event)
		{
			canvas3D.saveFrekdata();
			System.exit(0);
		}
	}
	/**
	 * metode som setter canasen i forhold til strrelsen p panel strrelsen
	 * vil oppdaterer canvas omrde i forhold til brukerens forminsking eller kning av vinduet
	 *
	 */
	
	private void setWindowSize()
	{
		int width=appPanel.getWidth();
		int height=appPanel.getHeight();

		canvas3D.setSize(width,height);
	

	}
	private class ComponentResized extends ComponentAdapter
	{
		//nr framen har forandret strrelse s settes
		//vindustrrelsen i forhold til dette
		public void componentResized (ComponentEvent event)
		{
			
			setWindowSize();
		}
		
	}

}